Attribute VB_Name = "modGlobal"
Option Explicit

'--- APIS e Funes do Exemplo Sem Barra de Progresso
Public Declare Function SHFileOperation Lib "shell32.dll" _
       Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) _
       As Long

Public Const FO_COPY As Long = &H2
Public Const FOF_ALLOWUNDO As Long = &H40

Public Type SHFILEOPSTRUCT
    hWnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Boolean
    hNameMappings As Long
    lpszProgressTitle As String
End Type

'--- APIS e Funes do Exemplo Com Barra de Progresso
Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Type SHITEMID
     cb As Long
     abID As Byte
End Type

Type ITEMIDLIST
     mkid As SHITEMID
End Type

Type BROWSEINFO
     hOwner As Long
     pidlRoot As Long
     pszDisplayName As String
     lpszTitle As String
     ulFlags As Long
     lpfn As Long
     lParam As Long
     iImage As Long
End Type

Public Const NOERROR = 0

Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000

Public Sub CopiarArq(Origem As String, Destino As String)
    Dim RST As Long
    Dim FLOP As SHFILEOPSTRUCT
    
    FLOP.hWnd = 0
    FLOP.wFunc = FO_COPY
    
    'Arquivo de origem:
    FLOP.pFrom = Origem & vbNullChar & vbNullChar
    
    'Para copiar TODOS os arquivos, use:
    'FLOP.pFrom = "C:\*.*" & vbNullChar & vbNullChar
    
    'Diretrio ou arquivo de destino:
    FLOP.pTo = Destino & vbNullChar & vbNullChar
    
    FLOP.fFlags = FOF_ALLOWUNDO
    RST = SHFileOperation(FLOP)
    
    If RST <> 0 Then
      'Erro na cpia
      MsgBox Err.LastDllError, vbCritical Or vbOKOnly
    Else
      If FLOP.fAnyOperationsAborted <> 0 Then
        MsgBox "Falha na cpia!!!", vbCritical Or vbOKOnly
      End If
    End If
End Sub

